/**
 * @brief bex.import.hpp 是根据函数列表自动生成的。
 * 使用时请在 bex.hpp 之后包含。
 */
#ifndef BALTAM_BEX_IMPORT_HPP
#define BALTAM_BEX_IMPORT_HPP

namespace bex {
BALTAM_LOCAL extern void * bex_handle;
BALTAM_LOCAL extern decltype(&bxAddCXXClass_impl) __bxAddCXXClass_impl;
BALTAM_LOCAL extern decltype(&bxAsCStr) __bxAsCStr;
BALTAM_LOCAL extern decltype(&bxAsInt) __bxAsInt;
BALTAM_LOCAL extern decltype(&bxCalcSingleSubscript) __bxCalcSingleSubscript;
BALTAM_LOCAL extern decltype(&bxCreateCellMatrix) __bxCreateCellMatrix;
BALTAM_LOCAL extern decltype(&bxCreateCharMatrixFromStrings) __bxCreateCharMatrixFromStrings;
BALTAM_LOCAL extern decltype(&bxCreateComplexDoubleScalar) __bxCreateComplexDoubleScalar;
BALTAM_LOCAL extern decltype(&bxCreateComplexSingleScalar) __bxCreateComplexSingleScalar;
BALTAM_LOCAL extern decltype(&bxCreateCStruct) __bxCreateCStruct;
BALTAM_LOCAL extern decltype(&bxCreateDoubleMatrix) __bxCreateDoubleMatrix;
BALTAM_LOCAL extern decltype(&bxCreateDoubleScalar) __bxCreateDoubleScalar;
BALTAM_LOCAL extern decltype(&bxCreateExtObj_v) __bxCreateExtObj_v;
BALTAM_LOCAL extern decltype(&bxCreateInt32Scalar) __bxCreateInt32Scalar;
BALTAM_LOCAL extern decltype(&bxCreateInt64Scalar) __bxCreateInt64Scalar;
BALTAM_LOCAL extern decltype(&bxCreateLogicalMatrix) __bxCreateLogicalMatrix;
BALTAM_LOCAL extern decltype(&bxCreateLogicalScalar) __bxCreateLogicalScalar;
BALTAM_LOCAL extern decltype(&bxCreateNumericMatrix) __bxCreateNumericMatrix;
BALTAM_LOCAL extern decltype(&bxCreateSingleScalar) __bxCreateSingleScalar;
BALTAM_LOCAL extern decltype(&bxCreateSparse) __bxCreateSparse;
BALTAM_LOCAL extern decltype(&bxCreateSparseLogicalMatrix) __bxCreateSparseLogicalMatrix;
BALTAM_LOCAL extern decltype(&bxCreateSparseNumericMatrix) __bxCreateSparseNumericMatrix;
BALTAM_LOCAL extern decltype(&bxCreateString) __bxCreateString;
BALTAM_LOCAL extern decltype(&bxCreateStringMatrix) __bxCreateStringMatrix;
BALTAM_LOCAL extern decltype(&bxCreateStringMatrixFromStrings) __bxCreateStringMatrixFromStrings;
BALTAM_LOCAL extern decltype(&bxCreateStringObj) __bxCreateStringObj;
BALTAM_LOCAL extern decltype(&bxCreateStringScalar) __bxCreateStringScalar;
BALTAM_LOCAL extern decltype(&bxCreateStructMatrix) __bxCreateStructMatrix;
BALTAM_LOCAL extern decltype(&bxDestroyArray) __bxDestroyArray;
BALTAM_LOCAL extern decltype(&bxDuplicateArray) __bxDuplicateArray;
BALTAM_LOCAL extern decltype(&bxDuplicateArrayS) __bxDuplicateArrayS;
BALTAM_LOCAL extern decltype(&bxErrMsgTxt) __bxErrMsgTxt;
BALTAM_LOCAL extern decltype(&bxF2KQuery) __bxF2KQuery;
BALTAM_LOCAL extern decltype(&bxGetCell) __bxGetCell;
BALTAM_LOCAL extern decltype(&bxGetChars) __bxGetChars;
BALTAM_LOCAL extern decltype(&bxGetClassID) __bxGetClassID;
BALTAM_LOCAL extern decltype(&bxGetComplexDoubles) __bxGetComplexDoubles;
BALTAM_LOCAL extern decltype(&bxGetComplexSingles) __bxGetComplexSingles;
BALTAM_LOCAL extern decltype(&bxGetCStruct) __bxGetCStruct;
BALTAM_LOCAL extern decltype(&bxGetDoubles) __bxGetDoubles;
BALTAM_LOCAL extern decltype(&bxGetExtObj_impl) __bxGetExtObj_impl;
BALTAM_LOCAL extern decltype(&bxGetField) __bxGetField;
BALTAM_LOCAL extern decltype(&bxGetFunctionHandleData) __bxGetFunctionHandleData;
BALTAM_LOCAL extern decltype(&bxGetFunctionHandleType) __bxGetFunctionHandleType;
BALTAM_LOCAL extern decltype(&bxGetInt32s) __bxGetInt32s;
BALTAM_LOCAL extern decltype(&bxGetInt64s) __bxGetInt64s;
BALTAM_LOCAL extern decltype(&bxGetIr) __bxGetIr;
BALTAM_LOCAL extern decltype(&bxGetJc) __bxGetJc;
BALTAM_LOCAL extern decltype(&bxGetLogicals) __bxGetLogicals;
BALTAM_LOCAL extern decltype(&bxGetM) __bxGetM;
BALTAM_LOCAL extern decltype(&bxGetN) __bxGetN;
BALTAM_LOCAL extern decltype(&bxGetNnz) __bxGetNnz;
BALTAM_LOCAL extern decltype(&bxGetNumberOfFields) __bxGetNumberOfFields;
BALTAM_LOCAL extern decltype(&bxGetNzmax) __bxGetNzmax;
BALTAM_LOCAL extern decltype(&bxGetPr) __bxGetPr;
BALTAM_LOCAL extern decltype(&bxGetSingles) __bxGetSingles;
BALTAM_LOCAL extern decltype(&bxGetSparseComplexDoubles) __bxGetSparseComplexDoubles;
BALTAM_LOCAL extern decltype(&bxGetSparseComplexSingles) __bxGetSparseComplexSingles;
BALTAM_LOCAL extern decltype(&bxGetSparseDoubles) __bxGetSparseDoubles;
BALTAM_LOCAL extern decltype(&bxGetSparseLogicals) __bxGetSparseLogicals;
BALTAM_LOCAL extern decltype(&bxGetSparseSingles) __bxGetSparseSingles;
BALTAM_LOCAL extern decltype(&bxGetString) __bxGetString;
BALTAM_LOCAL extern decltype(&bxGetStringDataPr) __bxGetStringDataPr;
BALTAM_LOCAL extern decltype(&bxGetStringLen) __bxGetStringLen;
BALTAM_LOCAL extern decltype(&bxGetStringLength) __bxGetStringLength;
BALTAM_LOCAL extern decltype(&bxIsCell) __bxIsCell;
BALTAM_LOCAL extern decltype(&bxIsChar) __bxIsChar;
BALTAM_LOCAL extern decltype(&bxIsComplex) __bxIsComplex;
BALTAM_LOCAL extern decltype(&bxIsComplexDouble) __bxIsComplexDouble;
BALTAM_LOCAL extern decltype(&bxIsComplexSingle) __bxIsComplexSingle;
BALTAM_LOCAL extern decltype(&bxIsDouble) __bxIsDouble;
BALTAM_LOCAL extern decltype(&bxIsFunctionHandle) __bxIsFunctionHandle;
BALTAM_LOCAL extern decltype(&bxIsInt32) __bxIsInt32;
BALTAM_LOCAL extern decltype(&bxIsInt64) __bxIsInt64;
BALTAM_LOCAL extern decltype(&bxIsLogical) __bxIsLogical;
BALTAM_LOCAL extern decltype(&bxIsRealDouble) __bxIsRealDouble;
BALTAM_LOCAL extern decltype(&bxIsRealSingle) __bxIsRealSingle;
BALTAM_LOCAL extern decltype(&bxIsSingle) __bxIsSingle;
BALTAM_LOCAL extern decltype(&bxIsSparse) __bxIsSparse;
BALTAM_LOCAL extern decltype(&bxIsSparseComplexDouble) __bxIsSparseComplexDouble;
BALTAM_LOCAL extern decltype(&bxIsSparseComplexSingle) __bxIsSparseComplexSingle;
BALTAM_LOCAL extern decltype(&bxIsSparseLogical) __bxIsSparseLogical;
BALTAM_LOCAL extern decltype(&bxIsSparseRealDouble) __bxIsSparseRealDouble;
BALTAM_LOCAL extern decltype(&bxIsSparseRealSingle) __bxIsSparseRealSingle;
BALTAM_LOCAL extern decltype(&bxIsString) __bxIsString;
BALTAM_LOCAL extern decltype(&bxIsStruct) __bxIsStruct;
BALTAM_LOCAL extern decltype(&bxK2FQuery) __bxK2FQuery;
BALTAM_LOCAL extern decltype(&bxPrintf) __bxPrintf;
BALTAM_LOCAL extern decltype(&bxRegisterBinaryOperator) __bxRegisterBinaryOperator;
BALTAM_LOCAL extern decltype(&bxRegisterBinaryOperatorID) __bxRegisterBinaryOperatorID;
BALTAM_LOCAL extern decltype(&bxRegisterCStruct) __bxRegisterCStruct;
BALTAM_LOCAL extern decltype(&bxRegisterTernaryOperator) __bxRegisterTernaryOperator;
BALTAM_LOCAL extern decltype(&bxRegisterTernaryOperatorID) __bxRegisterTernaryOperatorID;
BALTAM_LOCAL extern decltype(&bxRegisterUnaryOperator) __bxRegisterUnaryOperator;
BALTAM_LOCAL extern decltype(&bxRegisterUnaryOperatorID) __bxRegisterUnaryOperatorID;
BALTAM_LOCAL extern decltype(&bxRemoveField) __bxRemoveField;
BALTAM_LOCAL extern decltype(&bxResize) __bxResize;
BALTAM_LOCAL extern decltype(&bxSetCell) __bxSetCell;
BALTAM_LOCAL extern decltype(&bxSetField) __bxSetField;
BALTAM_LOCAL extern decltype(&bxSetM) __bxSetM;
BALTAM_LOCAL extern decltype(&bxSetN) __bxSetN;
BALTAM_LOCAL extern decltype(&bxSetNzmax) __bxSetNzmax;
BALTAM_LOCAL extern decltype(&bxSetString) __bxSetString;
BALTAM_LOCAL extern decltype(&bxSetStringFromCStr) __bxSetStringFromCStr;
BALTAM_LOCAL extern decltype(&bxSparseFinalize) __bxSparseFinalize;
BALTAM_LOCAL extern decltype(&bxTypeCStr) __bxTypeCStr;

}

#if defined(__WIN32__) || defined(__CYGWIN__) || defined(__MINGW32__)
#include <Windows.h>
#define BALTAM_BEX_IMPORT_FCN_FROM(p) \
*(void **) (&bex::__bxAddCXXClass_impl) = (void*)GetProcAddress((HMODULE)p, "bxAddCXXClass_impl"); \
*(void **) (&bex::__bxAsCStr) = (void*)GetProcAddress((HMODULE)p, "bxAsCStr"); \
*(void **) (&bex::__bxAsInt) = (void*)GetProcAddress((HMODULE)p, "bxAsInt"); \
*(void **) (&bex::__bxCalcSingleSubscript) = (void*)GetProcAddress((HMODULE)p, "bxCalcSingleSubscript"); \
*(void **) (&bex::__bxCreateCellMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateCellMatrix"); \
*(void **) (&bex::__bxCreateCharMatrixFromStrings) = (void*)GetProcAddress((HMODULE)p, "bxCreateCharMatrixFromStrings"); \
*(void **) (&bex::__bxCreateComplexDoubleScalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateComplexDoubleScalar"); \
*(void **) (&bex::__bxCreateComplexSingleScalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateComplexSingleScalar"); \
*(void **) (&bex::__bxCreateCStruct) = (void*)GetProcAddress((HMODULE)p, "bxCreateCStruct"); \
*(void **) (&bex::__bxCreateDoubleMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateDoubleMatrix"); \
*(void **) (&bex::__bxCreateDoubleScalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateDoubleScalar"); \
*(void **) (&bex::__bxCreateExtObj_v) = (void*)GetProcAddress((HMODULE)p, "bxCreateExtObj_v"); \
*(void **) (&bex::__bxCreateInt32Scalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateInt32Scalar"); \
*(void **) (&bex::__bxCreateInt64Scalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateInt64Scalar"); \
*(void **) (&bex::__bxCreateLogicalMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateLogicalMatrix"); \
*(void **) (&bex::__bxCreateLogicalScalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateLogicalScalar"); \
*(void **) (&bex::__bxCreateNumericMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateNumericMatrix"); \
*(void **) (&bex::__bxCreateSingleScalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateSingleScalar"); \
*(void **) (&bex::__bxCreateSparse) = (void*)GetProcAddress((HMODULE)p, "bxCreateSparse"); \
*(void **) (&bex::__bxCreateSparseLogicalMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateSparseLogicalMatrix"); \
*(void **) (&bex::__bxCreateSparseNumericMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateSparseNumericMatrix"); \
*(void **) (&bex::__bxCreateString) = (void*)GetProcAddress((HMODULE)p, "bxCreateString"); \
*(void **) (&bex::__bxCreateStringMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateStringMatrix"); \
*(void **) (&bex::__bxCreateStringMatrixFromStrings) = (void*)GetProcAddress((HMODULE)p, "bxCreateStringMatrixFromStrings"); \
*(void **) (&bex::__bxCreateStringObj) = (void*)GetProcAddress((HMODULE)p, "bxCreateStringObj"); \
*(void **) (&bex::__bxCreateStringScalar) = (void*)GetProcAddress((HMODULE)p, "bxCreateStringScalar"); \
*(void **) (&bex::__bxCreateStructMatrix) = (void*)GetProcAddress((HMODULE)p, "bxCreateStructMatrix"); \
*(void **) (&bex::__bxDestroyArray) = (void*)GetProcAddress((HMODULE)p, "bxDestroyArray"); \
*(void **) (&bex::__bxDuplicateArray) = (void*)GetProcAddress((HMODULE)p, "bxDuplicateArray"); \
*(void **) (&bex::__bxDuplicateArrayS) = (void*)GetProcAddress((HMODULE)p, "bxDuplicateArrayS"); \
*(void **) (&bex::__bxErrMsgTxt) = (void*)GetProcAddress((HMODULE)p, "bxErrMsgTxt"); \
*(void **) (&bex::__bxF2KQuery) = (void*)GetProcAddress((HMODULE)p, "bxF2KQuery"); \
*(void **) (&bex::__bxGetCell) = (void*)GetProcAddress((HMODULE)p, "bxGetCell"); \
*(void **) (&bex::__bxGetChars) = (void*)GetProcAddress((HMODULE)p, "bxGetChars"); \
*(void **) (&bex::__bxGetClassID) = (void*)GetProcAddress((HMODULE)p, "bxGetClassID"); \
*(void **) (&bex::__bxGetComplexDoubles) = (void*)GetProcAddress((HMODULE)p, "bxGetComplexDoubles"); \
*(void **) (&bex::__bxGetComplexSingles) = (void*)GetProcAddress((HMODULE)p, "bxGetComplexSingles"); \
*(void **) (&bex::__bxGetCStruct) = (void*)GetProcAddress((HMODULE)p, "bxGetCStruct"); \
*(void **) (&bex::__bxGetDoubles) = (void*)GetProcAddress((HMODULE)p, "bxGetDoubles"); \
*(void **) (&bex::__bxGetExtObj_impl) = (void*)GetProcAddress((HMODULE)p, "bxGetExtObj_impl"); \
*(void **) (&bex::__bxGetField) = (void*)GetProcAddress((HMODULE)p, "bxGetField"); \
*(void **) (&bex::__bxGetFunctionHandleData) = (void*)GetProcAddress((HMODULE)p, "bxGetFunctionHandleData"); \
*(void **) (&bex::__bxGetFunctionHandleType) = (void*)GetProcAddress((HMODULE)p, "bxGetFunctionHandleType"); \
*(void **) (&bex::__bxGetInt32s) = (void*)GetProcAddress((HMODULE)p, "bxGetInt32s"); \
*(void **) (&bex::__bxGetInt64s) = (void*)GetProcAddress((HMODULE)p, "bxGetInt64s"); \
*(void **) (&bex::__bxGetIr) = (void*)GetProcAddress((HMODULE)p, "bxGetIr"); \
*(void **) (&bex::__bxGetJc) = (void*)GetProcAddress((HMODULE)p, "bxGetJc"); \
*(void **) (&bex::__bxGetLogicals) = (void*)GetProcAddress((HMODULE)p, "bxGetLogicals"); \
*(void **) (&bex::__bxGetM) = (void*)GetProcAddress((HMODULE)p, "bxGetM"); \
*(void **) (&bex::__bxGetN) = (void*)GetProcAddress((HMODULE)p, "bxGetN"); \
*(void **) (&bex::__bxGetNnz) = (void*)GetProcAddress((HMODULE)p, "bxGetNnz"); \
*(void **) (&bex::__bxGetNumberOfFields) = (void*)GetProcAddress((HMODULE)p, "bxGetNumberOfFields"); \
*(void **) (&bex::__bxGetNzmax) = (void*)GetProcAddress((HMODULE)p, "bxGetNzmax"); \
*(void **) (&bex::__bxGetPr) = (void*)GetProcAddress((HMODULE)p, "bxGetPr"); \
*(void **) (&bex::__bxGetSingles) = (void*)GetProcAddress((HMODULE)p, "bxGetSingles"); \
*(void **) (&bex::__bxGetSparseComplexDoubles) = (void*)GetProcAddress((HMODULE)p, "bxGetSparseComplexDoubles"); \
*(void **) (&bex::__bxGetSparseComplexSingles) = (void*)GetProcAddress((HMODULE)p, "bxGetSparseComplexSingles"); \
*(void **) (&bex::__bxGetSparseDoubles) = (void*)GetProcAddress((HMODULE)p, "bxGetSparseDoubles"); \
*(void **) (&bex::__bxGetSparseLogicals) = (void*)GetProcAddress((HMODULE)p, "bxGetSparseLogicals"); \
*(void **) (&bex::__bxGetSparseSingles) = (void*)GetProcAddress((HMODULE)p, "bxGetSparseSingles"); \
*(void **) (&bex::__bxGetString) = (void*)GetProcAddress((HMODULE)p, "bxGetString"); \
*(void **) (&bex::__bxGetStringDataPr) = (void*)GetProcAddress((HMODULE)p, "bxGetStringDataPr"); \
*(void **) (&bex::__bxGetStringLen) = (void*)GetProcAddress((HMODULE)p, "bxGetStringLen"); \
*(void **) (&bex::__bxGetStringLength) = (void*)GetProcAddress((HMODULE)p, "bxGetStringLength"); \
*(void **) (&bex::__bxIsCell) = (void*)GetProcAddress((HMODULE)p, "bxIsCell"); \
*(void **) (&bex::__bxIsChar) = (void*)GetProcAddress((HMODULE)p, "bxIsChar"); \
*(void **) (&bex::__bxIsComplex) = (void*)GetProcAddress((HMODULE)p, "bxIsComplex"); \
*(void **) (&bex::__bxIsComplexDouble) = (void*)GetProcAddress((HMODULE)p, "bxIsComplexDouble"); \
*(void **) (&bex::__bxIsComplexSingle) = (void*)GetProcAddress((HMODULE)p, "bxIsComplexSingle"); \
*(void **) (&bex::__bxIsDouble) = (void*)GetProcAddress((HMODULE)p, "bxIsDouble"); \
*(void **) (&bex::__bxIsFunctionHandle) = (void*)GetProcAddress((HMODULE)p, "bxIsFunctionHandle"); \
*(void **) (&bex::__bxIsInt32) = (void*)GetProcAddress((HMODULE)p, "bxIsInt32"); \
*(void **) (&bex::__bxIsInt64) = (void*)GetProcAddress((HMODULE)p, "bxIsInt64"); \
*(void **) (&bex::__bxIsLogical) = (void*)GetProcAddress((HMODULE)p, "bxIsLogical"); \
*(void **) (&bex::__bxIsRealDouble) = (void*)GetProcAddress((HMODULE)p, "bxIsRealDouble"); \
*(void **) (&bex::__bxIsRealSingle) = (void*)GetProcAddress((HMODULE)p, "bxIsRealSingle"); \
*(void **) (&bex::__bxIsSingle) = (void*)GetProcAddress((HMODULE)p, "bxIsSingle"); \
*(void **) (&bex::__bxIsSparse) = (void*)GetProcAddress((HMODULE)p, "bxIsSparse"); \
*(void **) (&bex::__bxIsSparseComplexDouble) = (void*)GetProcAddress((HMODULE)p, "bxIsSparseComplexDouble"); \
*(void **) (&bex::__bxIsSparseComplexSingle) = (void*)GetProcAddress((HMODULE)p, "bxIsSparseComplexSingle"); \
*(void **) (&bex::__bxIsSparseLogical) = (void*)GetProcAddress((HMODULE)p, "bxIsSparseLogical"); \
*(void **) (&bex::__bxIsSparseRealDouble) = (void*)GetProcAddress((HMODULE)p, "bxIsSparseRealDouble"); \
*(void **) (&bex::__bxIsSparseRealSingle) = (void*)GetProcAddress((HMODULE)p, "bxIsSparseRealSingle"); \
*(void **) (&bex::__bxIsString) = (void*)GetProcAddress((HMODULE)p, "bxIsString"); \
*(void **) (&bex::__bxIsStruct) = (void*)GetProcAddress((HMODULE)p, "bxIsStruct"); \
*(void **) (&bex::__bxK2FQuery) = (void*)GetProcAddress((HMODULE)p, "bxK2FQuery"); \
*(void **) (&bex::__bxPrintf) = (void*)GetProcAddress((HMODULE)p, "bxPrintf"); \
*(void **) (&bex::__bxRegisterBinaryOperator) = (void*)GetProcAddress((HMODULE)p, "bxRegisterBinaryOperator"); \
*(void **) (&bex::__bxRegisterBinaryOperatorID) = (void*)GetProcAddress((HMODULE)p, "bxRegisterBinaryOperatorID"); \
*(void **) (&bex::__bxRegisterCStruct) = (void*)GetProcAddress((HMODULE)p, "bxRegisterCStruct"); \
*(void **) (&bex::__bxRegisterTernaryOperator) = (void*)GetProcAddress((HMODULE)p, "bxRegisterTernaryOperator"); \
*(void **) (&bex::__bxRegisterTernaryOperatorID) = (void*)GetProcAddress((HMODULE)p, "bxRegisterTernaryOperatorID"); \
*(void **) (&bex::__bxRegisterUnaryOperator) = (void*)GetProcAddress((HMODULE)p, "bxRegisterUnaryOperator"); \
*(void **) (&bex::__bxRegisterUnaryOperatorID) = (void*)GetProcAddress((HMODULE)p, "bxRegisterUnaryOperatorID"); \
*(void **) (&bex::__bxRemoveField) = (void*)GetProcAddress((HMODULE)p, "bxRemoveField"); \
*(void **) (&bex::__bxResize) = (void*)GetProcAddress((HMODULE)p, "bxResize"); \
*(void **) (&bex::__bxSetCell) = (void*)GetProcAddress((HMODULE)p, "bxSetCell"); \
*(void **) (&bex::__bxSetField) = (void*)GetProcAddress((HMODULE)p, "bxSetField"); \
*(void **) (&bex::__bxSetM) = (void*)GetProcAddress((HMODULE)p, "bxSetM"); \
*(void **) (&bex::__bxSetN) = (void*)GetProcAddress((HMODULE)p, "bxSetN"); \
*(void **) (&bex::__bxSetNzmax) = (void*)GetProcAddress((HMODULE)p, "bxSetNzmax"); \
*(void **) (&bex::__bxSetString) = (void*)GetProcAddress((HMODULE)p, "bxSetString"); \
*(void **) (&bex::__bxSetStringFromCStr) = (void*)GetProcAddress((HMODULE)p, "bxSetStringFromCStr"); \
*(void **) (&bex::__bxSparseFinalize) = (void*)GetProcAddress((HMODULE)p, "bxSparseFinalize"); \
*(void **) (&bex::__bxTypeCStr) = (void*)GetProcAddress((HMODULE)p, "bxTypeCStr"); \

#else
#include <dlfcn.h>
#define BALTAM_BEX_IMPORT_FCN_FROM(p) \
*(void **) (&bex::__bxAddCXXClass_impl) = dlsym(p, "bxAddCXXClass_impl"); \
*(void **) (&bex::__bxAsCStr) = dlsym(p, "bxAsCStr"); \
*(void **) (&bex::__bxAsInt) = dlsym(p, "bxAsInt"); \
*(void **) (&bex::__bxCalcSingleSubscript) = dlsym(p, "bxCalcSingleSubscript"); \
*(void **) (&bex::__bxCreateCellMatrix) = dlsym(p, "bxCreateCellMatrix"); \
*(void **) (&bex::__bxCreateCharMatrixFromStrings) = dlsym(p, "bxCreateCharMatrixFromStrings"); \
*(void **) (&bex::__bxCreateComplexDoubleScalar) = dlsym(p, "bxCreateComplexDoubleScalar"); \
*(void **) (&bex::__bxCreateComplexSingleScalar) = dlsym(p, "bxCreateComplexSingleScalar"); \
*(void **) (&bex::__bxCreateCStruct) = dlsym(p, "bxCreateCStruct"); \
*(void **) (&bex::__bxCreateDoubleMatrix) = dlsym(p, "bxCreateDoubleMatrix"); \
*(void **) (&bex::__bxCreateDoubleScalar) = dlsym(p, "bxCreateDoubleScalar"); \
*(void **) (&bex::__bxCreateExtObj_v) = dlsym(p, "bxCreateExtObj_v"); \
*(void **) (&bex::__bxCreateInt32Scalar) = dlsym(p, "bxCreateInt32Scalar"); \
*(void **) (&bex::__bxCreateInt64Scalar) = dlsym(p, "bxCreateInt64Scalar"); \
*(void **) (&bex::__bxCreateLogicalMatrix) = dlsym(p, "bxCreateLogicalMatrix"); \
*(void **) (&bex::__bxCreateLogicalScalar) = dlsym(p, "bxCreateLogicalScalar"); \
*(void **) (&bex::__bxCreateNumericMatrix) = dlsym(p, "bxCreateNumericMatrix"); \
*(void **) (&bex::__bxCreateSingleScalar) = dlsym(p, "bxCreateSingleScalar"); \
*(void **) (&bex::__bxCreateSparse) = dlsym(p, "bxCreateSparse"); \
*(void **) (&bex::__bxCreateSparseLogicalMatrix) = dlsym(p, "bxCreateSparseLogicalMatrix"); \
*(void **) (&bex::__bxCreateSparseNumericMatrix) = dlsym(p, "bxCreateSparseNumericMatrix"); \
*(void **) (&bex::__bxCreateString) = dlsym(p, "bxCreateString"); \
*(void **) (&bex::__bxCreateStringMatrix) = dlsym(p, "bxCreateStringMatrix"); \
*(void **) (&bex::__bxCreateStringMatrixFromStrings) = dlsym(p, "bxCreateStringMatrixFromStrings"); \
*(void **) (&bex::__bxCreateStringObj) = dlsym(p, "bxCreateStringObj"); \
*(void **) (&bex::__bxCreateStringScalar) = dlsym(p, "bxCreateStringScalar"); \
*(void **) (&bex::__bxCreateStructMatrix) = dlsym(p, "bxCreateStructMatrix"); \
*(void **) (&bex::__bxDestroyArray) = dlsym(p, "bxDestroyArray"); \
*(void **) (&bex::__bxDuplicateArray) = dlsym(p, "bxDuplicateArray"); \
*(void **) (&bex::__bxDuplicateArrayS) = dlsym(p, "bxDuplicateArrayS"); \
*(void **) (&bex::__bxErrMsgTxt) = dlsym(p, "bxErrMsgTxt"); \
*(void **) (&bex::__bxF2KQuery) = dlsym(p, "bxF2KQuery"); \
*(void **) (&bex::__bxGetCell) = dlsym(p, "bxGetCell"); \
*(void **) (&bex::__bxGetChars) = dlsym(p, "bxGetChars"); \
*(void **) (&bex::__bxGetClassID) = dlsym(p, "bxGetClassID"); \
*(void **) (&bex::__bxGetComplexDoubles) = dlsym(p, "bxGetComplexDoubles"); \
*(void **) (&bex::__bxGetComplexSingles) = dlsym(p, "bxGetComplexSingles"); \
*(void **) (&bex::__bxGetCStruct) = dlsym(p, "bxGetCStruct"); \
*(void **) (&bex::__bxGetDoubles) = dlsym(p, "bxGetDoubles"); \
*(void **) (&bex::__bxGetExtObj_impl) = dlsym(p, "bxGetExtObj_impl"); \
*(void **) (&bex::__bxGetField) = dlsym(p, "bxGetField"); \
*(void **) (&bex::__bxGetFunctionHandleData) = dlsym(p, "bxGetFunctionHandleData"); \
*(void **) (&bex::__bxGetFunctionHandleType) = dlsym(p, "bxGetFunctionHandleType"); \
*(void **) (&bex::__bxGetInt32s) = dlsym(p, "bxGetInt32s"); \
*(void **) (&bex::__bxGetInt64s) = dlsym(p, "bxGetInt64s"); \
*(void **) (&bex::__bxGetIr) = dlsym(p, "bxGetIr"); \
*(void **) (&bex::__bxGetJc) = dlsym(p, "bxGetJc"); \
*(void **) (&bex::__bxGetLogicals) = dlsym(p, "bxGetLogicals"); \
*(void **) (&bex::__bxGetM) = dlsym(p, "bxGetM"); \
*(void **) (&bex::__bxGetN) = dlsym(p, "bxGetN"); \
*(void **) (&bex::__bxGetNnz) = dlsym(p, "bxGetNnz"); \
*(void **) (&bex::__bxGetNumberOfFields) = dlsym(p, "bxGetNumberOfFields"); \
*(void **) (&bex::__bxGetNzmax) = dlsym(p, "bxGetNzmax"); \
*(void **) (&bex::__bxGetPr) = dlsym(p, "bxGetPr"); \
*(void **) (&bex::__bxGetSingles) = dlsym(p, "bxGetSingles"); \
*(void **) (&bex::__bxGetSparseComplexDoubles) = dlsym(p, "bxGetSparseComplexDoubles"); \
*(void **) (&bex::__bxGetSparseComplexSingles) = dlsym(p, "bxGetSparseComplexSingles"); \
*(void **) (&bex::__bxGetSparseDoubles) = dlsym(p, "bxGetSparseDoubles"); \
*(void **) (&bex::__bxGetSparseLogicals) = dlsym(p, "bxGetSparseLogicals"); \
*(void **) (&bex::__bxGetSparseSingles) = dlsym(p, "bxGetSparseSingles"); \
*(void **) (&bex::__bxGetString) = dlsym(p, "bxGetString"); \
*(void **) (&bex::__bxGetStringDataPr) = dlsym(p, "bxGetStringDataPr"); \
*(void **) (&bex::__bxGetStringLen) = dlsym(p, "bxGetStringLen"); \
*(void **) (&bex::__bxGetStringLength) = dlsym(p, "bxGetStringLength"); \
*(void **) (&bex::__bxIsCell) = dlsym(p, "bxIsCell"); \
*(void **) (&bex::__bxIsChar) = dlsym(p, "bxIsChar"); \
*(void **) (&bex::__bxIsComplex) = dlsym(p, "bxIsComplex"); \
*(void **) (&bex::__bxIsComplexDouble) = dlsym(p, "bxIsComplexDouble"); \
*(void **) (&bex::__bxIsComplexSingle) = dlsym(p, "bxIsComplexSingle"); \
*(void **) (&bex::__bxIsDouble) = dlsym(p, "bxIsDouble"); \
*(void **) (&bex::__bxIsFunctionHandle) = dlsym(p, "bxIsFunctionHandle"); \
*(void **) (&bex::__bxIsInt32) = dlsym(p, "bxIsInt32"); \
*(void **) (&bex::__bxIsInt64) = dlsym(p, "bxIsInt64"); \
*(void **) (&bex::__bxIsLogical) = dlsym(p, "bxIsLogical"); \
*(void **) (&bex::__bxIsRealDouble) = dlsym(p, "bxIsRealDouble"); \
*(void **) (&bex::__bxIsRealSingle) = dlsym(p, "bxIsRealSingle"); \
*(void **) (&bex::__bxIsSingle) = dlsym(p, "bxIsSingle"); \
*(void **) (&bex::__bxIsSparse) = dlsym(p, "bxIsSparse"); \
*(void **) (&bex::__bxIsSparseComplexDouble) = dlsym(p, "bxIsSparseComplexDouble"); \
*(void **) (&bex::__bxIsSparseComplexSingle) = dlsym(p, "bxIsSparseComplexSingle"); \
*(void **) (&bex::__bxIsSparseLogical) = dlsym(p, "bxIsSparseLogical"); \
*(void **) (&bex::__bxIsSparseRealDouble) = dlsym(p, "bxIsSparseRealDouble"); \
*(void **) (&bex::__bxIsSparseRealSingle) = dlsym(p, "bxIsSparseRealSingle"); \
*(void **) (&bex::__bxIsString) = dlsym(p, "bxIsString"); \
*(void **) (&bex::__bxIsStruct) = dlsym(p, "bxIsStruct"); \
*(void **) (&bex::__bxK2FQuery) = dlsym(p, "bxK2FQuery"); \
*(void **) (&bex::__bxPrintf) = dlsym(p, "bxPrintf"); \
*(void **) (&bex::__bxRegisterBinaryOperator) = dlsym(p, "bxRegisterBinaryOperator"); \
*(void **) (&bex::__bxRegisterBinaryOperatorID) = dlsym(p, "bxRegisterBinaryOperatorID"); \
*(void **) (&bex::__bxRegisterCStruct) = dlsym(p, "bxRegisterCStruct"); \
*(void **) (&bex::__bxRegisterTernaryOperator) = dlsym(p, "bxRegisterTernaryOperator"); \
*(void **) (&bex::__bxRegisterTernaryOperatorID) = dlsym(p, "bxRegisterTernaryOperatorID"); \
*(void **) (&bex::__bxRegisterUnaryOperator) = dlsym(p, "bxRegisterUnaryOperator"); \
*(void **) (&bex::__bxRegisterUnaryOperatorID) = dlsym(p, "bxRegisterUnaryOperatorID"); \
*(void **) (&bex::__bxRemoveField) = dlsym(p, "bxRemoveField"); \
*(void **) (&bex::__bxResize) = dlsym(p, "bxResize"); \
*(void **) (&bex::__bxSetCell) = dlsym(p, "bxSetCell"); \
*(void **) (&bex::__bxSetField) = dlsym(p, "bxSetField"); \
*(void **) (&bex::__bxSetM) = dlsym(p, "bxSetM"); \
*(void **) (&bex::__bxSetN) = dlsym(p, "bxSetN"); \
*(void **) (&bex::__bxSetNzmax) = dlsym(p, "bxSetNzmax"); \
*(void **) (&bex::__bxSetString) = dlsym(p, "bxSetString"); \
*(void **) (&bex::__bxSetStringFromCStr) = dlsym(p, "bxSetStringFromCStr"); \
*(void **) (&bex::__bxSparseFinalize) = dlsym(p, "bxSparseFinalize"); \
*(void **) (&bex::__bxTypeCStr) = dlsym(p, "bxTypeCStr"); \

#endif

#define BALTAM_BEX_DEFINE_FCN_VARS \
namespace bex { \
void * bex_handle; \
decltype(&bxAddCXXClass_impl) __bxAddCXXClass_impl; \
decltype(&bxAsCStr) __bxAsCStr; \
decltype(&bxAsInt) __bxAsInt; \
decltype(&bxCalcSingleSubscript) __bxCalcSingleSubscript; \
decltype(&bxCreateCellMatrix) __bxCreateCellMatrix; \
decltype(&bxCreateCharMatrixFromStrings) __bxCreateCharMatrixFromStrings; \
decltype(&bxCreateComplexDoubleScalar) __bxCreateComplexDoubleScalar; \
decltype(&bxCreateComplexSingleScalar) __bxCreateComplexSingleScalar; \
decltype(&bxCreateCStruct) __bxCreateCStruct; \
decltype(&bxCreateDoubleMatrix) __bxCreateDoubleMatrix; \
decltype(&bxCreateDoubleScalar) __bxCreateDoubleScalar; \
decltype(&bxCreateExtObj_v) __bxCreateExtObj_v; \
decltype(&bxCreateInt32Scalar) __bxCreateInt32Scalar; \
decltype(&bxCreateInt64Scalar) __bxCreateInt64Scalar; \
decltype(&bxCreateLogicalMatrix) __bxCreateLogicalMatrix; \
decltype(&bxCreateLogicalScalar) __bxCreateLogicalScalar; \
decltype(&bxCreateNumericMatrix) __bxCreateNumericMatrix; \
decltype(&bxCreateSingleScalar) __bxCreateSingleScalar; \
decltype(&bxCreateSparse) __bxCreateSparse; \
decltype(&bxCreateSparseLogicalMatrix) __bxCreateSparseLogicalMatrix; \
decltype(&bxCreateSparseNumericMatrix) __bxCreateSparseNumericMatrix; \
decltype(&bxCreateString) __bxCreateString; \
decltype(&bxCreateStringMatrix) __bxCreateStringMatrix; \
decltype(&bxCreateStringMatrixFromStrings) __bxCreateStringMatrixFromStrings; \
decltype(&bxCreateStringObj) __bxCreateStringObj; \
decltype(&bxCreateStringScalar) __bxCreateStringScalar; \
decltype(&bxCreateStructMatrix) __bxCreateStructMatrix; \
decltype(&bxDestroyArray) __bxDestroyArray; \
decltype(&bxDuplicateArray) __bxDuplicateArray; \
decltype(&bxDuplicateArrayS) __bxDuplicateArrayS; \
decltype(&bxErrMsgTxt) __bxErrMsgTxt; \
decltype(&bxF2KQuery) __bxF2KQuery; \
decltype(&bxGetCell) __bxGetCell; \
decltype(&bxGetChars) __bxGetChars; \
decltype(&bxGetClassID) __bxGetClassID; \
decltype(&bxGetComplexDoubles) __bxGetComplexDoubles; \
decltype(&bxGetComplexSingles) __bxGetComplexSingles; \
decltype(&bxGetCStruct) __bxGetCStruct; \
decltype(&bxGetDoubles) __bxGetDoubles; \
decltype(&bxGetExtObj_impl) __bxGetExtObj_impl; \
decltype(&bxGetField) __bxGetField; \
decltype(&bxGetFunctionHandleData) __bxGetFunctionHandleData; \
decltype(&bxGetFunctionHandleType) __bxGetFunctionHandleType; \
decltype(&bxGetInt32s) __bxGetInt32s; \
decltype(&bxGetInt64s) __bxGetInt64s; \
decltype(&bxGetIr) __bxGetIr; \
decltype(&bxGetJc) __bxGetJc; \
decltype(&bxGetLogicals) __bxGetLogicals; \
decltype(&bxGetM) __bxGetM; \
decltype(&bxGetN) __bxGetN; \
decltype(&bxGetNnz) __bxGetNnz; \
decltype(&bxGetNumberOfFields) __bxGetNumberOfFields; \
decltype(&bxGetNzmax) __bxGetNzmax; \
decltype(&bxGetPr) __bxGetPr; \
decltype(&bxGetSingles) __bxGetSingles; \
decltype(&bxGetSparseComplexDoubles) __bxGetSparseComplexDoubles; \
decltype(&bxGetSparseComplexSingles) __bxGetSparseComplexSingles; \
decltype(&bxGetSparseDoubles) __bxGetSparseDoubles; \
decltype(&bxGetSparseLogicals) __bxGetSparseLogicals; \
decltype(&bxGetSparseSingles) __bxGetSparseSingles; \
decltype(&bxGetString) __bxGetString; \
decltype(&bxGetStringDataPr) __bxGetStringDataPr; \
decltype(&bxGetStringLen) __bxGetStringLen; \
decltype(&bxGetStringLength) __bxGetStringLength; \
decltype(&bxIsCell) __bxIsCell; \
decltype(&bxIsChar) __bxIsChar; \
decltype(&bxIsComplex) __bxIsComplex; \
decltype(&bxIsComplexDouble) __bxIsComplexDouble; \
decltype(&bxIsComplexSingle) __bxIsComplexSingle; \
decltype(&bxIsDouble) __bxIsDouble; \
decltype(&bxIsFunctionHandle) __bxIsFunctionHandle; \
decltype(&bxIsInt32) __bxIsInt32; \
decltype(&bxIsInt64) __bxIsInt64; \
decltype(&bxIsLogical) __bxIsLogical; \
decltype(&bxIsRealDouble) __bxIsRealDouble; \
decltype(&bxIsRealSingle) __bxIsRealSingle; \
decltype(&bxIsSingle) __bxIsSingle; \
decltype(&bxIsSparse) __bxIsSparse; \
decltype(&bxIsSparseComplexDouble) __bxIsSparseComplexDouble; \
decltype(&bxIsSparseComplexSingle) __bxIsSparseComplexSingle; \
decltype(&bxIsSparseLogical) __bxIsSparseLogical; \
decltype(&bxIsSparseRealDouble) __bxIsSparseRealDouble; \
decltype(&bxIsSparseRealSingle) __bxIsSparseRealSingle; \
decltype(&bxIsString) __bxIsString; \
decltype(&bxIsStruct) __bxIsStruct; \
decltype(&bxK2FQuery) __bxK2FQuery; \
decltype(&bxPrintf) __bxPrintf; \
decltype(&bxRegisterBinaryOperator) __bxRegisterBinaryOperator; \
decltype(&bxRegisterBinaryOperatorID) __bxRegisterBinaryOperatorID; \
decltype(&bxRegisterCStruct) __bxRegisterCStruct; \
decltype(&bxRegisterTernaryOperator) __bxRegisterTernaryOperator; \
decltype(&bxRegisterTernaryOperatorID) __bxRegisterTernaryOperatorID; \
decltype(&bxRegisterUnaryOperator) __bxRegisterUnaryOperator; \
decltype(&bxRegisterUnaryOperatorID) __bxRegisterUnaryOperatorID; \
decltype(&bxRemoveField) __bxRemoveField; \
decltype(&bxResize) __bxResize; \
decltype(&bxSetCell) __bxSetCell; \
decltype(&bxSetField) __bxSetField; \
decltype(&bxSetM) __bxSetM; \
decltype(&bxSetN) __bxSetN; \
decltype(&bxSetNzmax) __bxSetNzmax; \
decltype(&bxSetString) __bxSetString; \
decltype(&bxSetStringFromCStr) __bxSetStringFromCStr; \
decltype(&bxSparseFinalize) __bxSparseFinalize; \
decltype(&bxTypeCStr) __bxTypeCStr; \
}

#endif

