%画二维三角形网格
%参数 Coord: 节点的坐标, 是一个 nx2 的矩阵，保存n个点的(x,y)坐标
%参数 Element: 三角形单元, 是一个 mx3的矩阵，保存m个单元的节点编号( 节点编号是从0开始的)
function DrawMesh2d(Coord, Element)
hold on
for i=1:size(Element,1)
	L = ... 
		[ Coord(Element(i,1)+1,:);Coord(Element(i,2)+1,:)
		Coord(Element(i,2)+1,:);Coord(Element(i,3)+1,:)  
		Coord(Element(i,3)+1,:);Coord(Element(i,1)+1,:)  
		];
		line(L(:,1),L(:,2));
end
hold off
title("剖分成三角形");
