%结构体的成员可以是匿名函数
func.f1=@(x)x^2;
func.f2=@(x)3*x;
func.f3=@(x)x^x;
% 取得结构体成员 (是一个匿名函数句柄)
fh = func.f1
% 或者 fh= func.('f1')
% 使用该句柄函数
fh(2) 
% 我么还支持下面的使用方式
func.('f1')(2)
func.f2(2)
% 如果结构成员的名字不是一个合法的变量名，例如
% func.2  = @(x) 2*x
% 这里的 2 不是一个合法的变量名，因此func.2 的写法是非法的
% 需要改成 func.('2') = @(x) 2*x
func.('2') = @(x)2*x
func.('2')(5) 
