% 二分法求 fh(x) =0 的解 , 
% 在实数范围内求解，
% fh: 实值函数的句柄
% x0, x1: 求解的范围[x0,x1]
% ep: 误差
% Nm: 最大的二分次数
function sol = bisectionEx1(fh, x0, x1, ep, Nm)
	close all, clf
while (fh(x1) * fh(x0) > 0)
	fprintf('猜的初始范围不对\n');
	x0 = input ('请输入x0:') ;
	x1 = input ('请输入x1:\n');
end

xlist = zeros(Nm,0);
xlist (1) = x0;

for i = 2 : Nm 
	barx = (x1 + x0) / 2;
	if fh(barx) * fh(x1) < 0
		x0 = barx;
	else
		x1 = barx;
	end
	xlist (i) = barx;
	if (abs(xlist(i) - xlist (i-1)) < ep)
		break
 	end
end
outStr = ['二分法求得根是', num2str(barx), '']

	subplot(1,2,1)
	plot(xlist(1:i),fh(xlist(1:i)),'*');
	xlabel('x'); ylabel('fh(x)')
	subplot(1,2,2)
	plot(1:i, xlist(1:i),'*');
	xlabel('迭代次数:i'); ylabel('第i次迭代后得到的x')
	title(['经过', num2str(i), '次二分得到的根是', num2str(xlist(i))])
end


