%快速傅立叶变换(FFT)的例子 

%加载插件
load_plugin("fft")

n = 8;
% p(x) = a0+a1*x + ... +a7 *x 
a=0:n-1;
% omega = exp(-i 2pi/8);
% 求p(x) 在 8 个点(omega^0, omega^1, ..., omega^8) 上值
f = fft(a)
%你可以验算 f(j) 是 p(omega^j) 
j = 1
omega = exp(-i * 2*pi/n);
s = 0; 
for k = 1:n
	s = s + a(k)*omega^(k-1); 
end
disp("f(1) - p(omega^1) = ")
disp(f(1) - s )

% 傅立叶逆变换
b = ifft(f);
disp("你可以看到a经过fft，然后再ifft后得到的结果和a相等")
disp("a-b= ")
disp(a-b)


