% global 使用距离
% case 1: 如果在外部 a 已经是一个全局变量
% 那么  global a 
% 将可以在当前的工作区使用使用外部定义的全局变量 a
% 而且在当前工作区对a的改变会反馈到外部的全局变量a. 
% case 2: 如果在外部 a 不是一个全局变量，那么
% 这里的global a 将和  a = [] 是等价的。 
function y = globalEx(x)
  global a 
  a = 5
  y = 2*x
end
