% load_plugin("some_plugin")
% 如果插件加载失败，执行就会中断
% 你可以使用 try_load_plugin("some_plugin") 来尝试加载插件 some_plugin
%
try_load_plugin("some_plugin")
disp("如果some_plugin不存在或者加载事变，你会看到返回逻辑值 false ")

if try_load_plugin("sparse")
	disp("加载插件sparse 成功")
	%成功后，你就可以使用sparse插件中的函数,如 sparse::size
	A = [ 0  1  0  1 ; 
		    1  0  0  0 
		    0  1  0  0 
		    0  0  1  0 ] 
	SA = sparse(A);
	mn = sparse::size(SA) ; % 这里的mn出来的类型是 int32
	% num2str目前只能接受 double 矩阵，因此我下面用 double(mn)得到double类型的矩阵
	disp(['稀疏矩阵 SA 的 行数 列数 是: ' , num2str(double(mn))])
else
	disp("加载插件sparse 失败")
end



