 clf; close all; clc; clear all;
load_plugin("time")
% mesh3d 是一个三维网格剖分程序
load_plugin("mesh")
%剖分区域是一个长方体
% [x_min,x_max]x[y_min,y_max]x[z_min,z_max]
% 每个方向上分别剖分出 nx, ny, nz 个点
x_min = 0 ; 
x_max = 1 ; 
nx = 2; 
y_min = 0 ; 
y_max = 1 ; 
ny = 2; 
z_min = 0 ; 
z_max = 1 ; 
nz = 2; 
%剖分网格，生成的网格的节点坐标保存在mesh_coords, 单元保存在mesh_elements
[mesh_coords, mesh_elements] = mesh3d("cubic",  ... 
	x_min, x_max, nx, ... 
	y_min, y_max, ny, ... 
	z_min, z_max, nz ... 
) 
Coord = mesh_coords;
Element = mesh_elements;
XXX = zeros(12*size(Element,1), 3);
for i=1:size(Element,1)
	XXX(12*(i-1)+1:12*i,:) = ... 
		[ Coord(Element(i,1)+1,:);Coord(Element(i,2)+1,:)
		Coord(Element(i,2)+1,:);Coord(Element(i,3)+1,:)  
		Coord(Element(i,3)+1,:);Coord(Element(i,1)+1,:)  
		Coord(Element(i,1)+1,:);Coord(Element(i,4)+1,:)  
		Coord(Element(i,2)+1,:);Coord(Element(i,4)+1,:)  
		Coord(Element(i,3)+1,:);Coord(Element(i,4)+1,:)  
		];
end

line(XXX(:,1),XXX(:,2),XXX(:,3),'Color','b');
title("长方体剖分成四面体");
unload_plugin("time")
unload_plugin("mesh")

