%版本1.9.3 会修复这个bug 227
%mesh(x,y,z)如果x,y,z都是同样大小的矩阵，自然可以画图。
%但是 bug227 是这样的情况, x 和 y是一个向量
%
%mesh(x,y,z) 
%如果x 和 y 都是向量，要求 x长度 和 z的列数相等 ， 
% y 的长度和 z 的行数相等，

% meshc, meshz, surf, surface, surfc 这些函数都具有同样的功能

%例如
x = 1:5
y = x
%都可以画图
mesh(x,y,rand(5))
mesh(x,y',rand(5))

x = 1:10
y = 1:5
% 注意x的长度是10, y的长度是5，z的size是5x10，而不是10x5
%
z = rand(5,10);
% 下面的写法都可以画图, 
mesh(x,y,z)
mesh(x,y',z)
mesh(x',y',z)
mesh(x',y,z)

%上面的z是5x10的，下面来个10x5的数据
% 注意第一个参数和第二个参数和刚才相比调换了次序
mesh(y,x,rand(10,5))
