% 嵌套函数举例
% 处理嵌套函数的时候，系统会把所有的变量都先处理一下，
% 如果这个变量在 mfnestedEx1 函数中曾经出现过
% 那么这个变量在 mfnestedEx1, son1, son2 中都是指向同一个
% 存储地址的。 
function mfnestedEx1 
x = 5
z = son2
z = son1

   function y = son1
% m 在mfnestedEx1中没有出现过，仅仅出现在 son2 中，那么它是son2
% 所特有的变量，如果我们使用 m = m +2 , 那么会报错说 m没有定义，
% 无法做加法 
% x 在mfnestedEx1 中定义过，那么son1, son2 的x 都指向同一个数据地址。 
%     m = m+2  
     y = x + 1
   end 

   function y = son2 
     m = 3 
     y = x + 1
   end 



end
