clf; close all; 
循环次数CT = 20:60;
新冠病毒的初始浓度 = 计算新冠初始浓度(循环次数CT);
hold on
plot(循环次数CT, 新冠病毒的初始浓度,'LineWidth',3) 
text(35, 1e-5, 'CT35', 'FontName', 'Times-Roman', 'FontSize', 24, 'Color', 'r')
line([35,35],[0,1e-5]);
text(40, 1e-5, 'CT40', 'FontName', 'Times-Roman', 'FontSize', 24, 'Color', [1,1,0.2])
line([40,40],[0,1e-5]);
xlabel("循环次数CT")
ylabel("新冠病毒的初始浓度") 
hold off

function 新冠病毒的初始浓度 = 计算新冠初始浓度(循环次数CT)
荧光反应要求的浓度 = 0.2; 
扩增效率Ex = 0.5; 
% 荧光反应要求的浓度 = 初始的新冠病毒的浓度 * (1+扩增效率Ex)^循环次数CT; 
新冠病毒的初始浓度 = 荧光反应要求的浓度 / (1+扩增效率Ex).^ 循环次数CT;
end
