% quiverEx2.m

[xg,yg]=meshgrid(0.1:0.1:3);
[n,m]=size(xg);

for i=1:n
	for j=1:m
		df=LotkaVolterra(1,[xg(i,j) yg(i,j)]);
		df=df/norm(df);
		u(i,j)=df(1);
		v(i,j)=df(2);
	end
end

axis square
quiver(xg,yg,u,v)

title("LotkaVoterrra 模型的相场图")
xlabel("物种1的数量")
xlabel("物种2的数量")
