function showmesh(filename)
filename = char(filename)
nodefile = fopen([filename '.n'],'r');
nnodes = fscanf(nodefile,'%d');
nnodes = nnodes(1);
nodedata = zeros(nnodes,4);
for i=1:nnodes
	for j=1:4
		nodedata(i,j) = fscanf(nodefile,'%f');
	end
end
fclose(nodefile);

sidefile = fopen([filename '.s'],'r');
nsides = fscanf(sidefile,'%d',1);
sidedata = zeros(nsides,6);
for i=1:nsides
	for j=1:6
		sidedata(i,j) = fscanf(sidefile,'%d');
	end
end
fclose(sidefile);

elefile = fopen([filename '.e'],'r');
neles = fscanf(elefile,'%d');
eledata = zeros(neles, 13);
for i=1:neles
	for j=1:13
		eledata(i,j) = fscanf(elefile,'%f');
	end
end
fclose(elefile);

clf
hold on
for i=1:nsides
	plot( ...
		[nodedata(sidedata(i,2)+1,2), nodedata(sidedata(i,3)+1,2)], ...
		[nodedata(sidedata(i,2)+1,3), nodedata(sidedata(i,3)+1,3)])
end
hold off

/*
clf
hold on
for i=1:neles
	fill( ...
		[nodedata(eledata(i,2)+1,2), nodedata(eledata(i,3)+1,2), nodedata(eledata(i,4)+1,2), ...
			nodedata(eledata(i,2)+1,2) ], ... 
		[nodedata(eledata(i,2)+1,3), nodedata(eledata(i,3)+1,3), nodedata(eledata(i,4)+1,3), ...
			nodedata(eledata(i,2)+1,3) ] )
end
hold off
*/

/*
clf
hold on
for i=1:neles
	for k = 5:7
		if  eledata(i,k) >-0.5
			plot( ...
				[eledata(i,11), eledata(eledata(i,k)+1,11)], ...
				[eledata(i,12), eledata(eledata(i,k)+1,12)] )
		end
	end
end
hold off
*/


