%球的参数方程
%x=cos(theta)*sin(phi)
%y=sin(theta)*sin(phi)
%z=cos(phi)
%theta 的范围[0,2\pi], phi的范围[0,\pi]
%  画的是单位球的赤道
pi = 4*atan(1.0)
N = 40;
x = zeros(N+1,N+1);
y = zeros(N+1,N+1);
z = zeros(N+1,N+1);
dtheta = 2*pi/N; 
dphi = pi/N; 
for i=1:(N+1)
	for j=1:(N+1)
		theta=(i-1)*dtheta;
		phi = (j-1)*dphi;
		x(i,j)=cos(theta)*sin(phi);
		y(i,j)=sin(theta)*sin(phi);
		z(i,j)=cos(phi);
	end
end

plot3(x(:,20),y(:,20),z(:,20))

