% 这个是要求4次插值吗？ 
% 4次多项式有5个系数，因此n=5 
n=5;
%[-1,1]区间被平均分成4分，形成5个节点。
x=linspace(-1,1,n);
% y = 1/(1+25x^2) , 计算每个节点上的函数值
% 上面的函数称为Runge函数, 由frunge.m实现
y=frunge(x);
plot(x,y,'r-*');
%插值函数将在m个点求值
m=21
x1=linspace(-1, 1, m);
y1=zeros(1,m);
for i=1:m
% 使用的是Lagrange插值法，计算Lagrange基函数
for k=1:n
a=1;
for j=1:k-1
a=a*(x1(1,i)-x(1,j))/(x(1,k)-x(1,j));
end
for j=k+1:n
a=a*(x1(1,i)-x(1,j))/(x(1,k)-x(1,j));
end
y1(1,i)=y1(1,i)+a*y(1,k);
end
end
plot(x1, y1,'b-+',x,y,'r-*')
