% 画北太天元的Logo
clear;clc;clf
b = 0.3419;
a = b/7;
c = 0.8354*b;
d = 1.25*a;
e = 0.9104*c;
f = 0.6568*b;  %0.636364*b;
g = 0.38*b;
h = 0.22917*b;
i = 0.38542*b;
j = 0.17708*b;
k = 0.7385*b;

% 是否绘制辅助线，1 为绘制， 0 为不绘制
plot_line = 0;
% 是否绘制坐标轴，1 为绘制， 0 为不绘制
plot_axis = 0;

% 一三象限
x1 = -1.2:0.01:1.2;
x2 = -1.2:0.01:1.2;
y1 = 0.95726 - x1;
y1_1 = 0.35043 -x1;
y1_2 = -0.33333 -x1;
y3 =  -x1 - 0.95726;
% 二四象限
y4 = x2 + 1;
y4_1 = x2 + 1 - f*sqrt(2);
y4_2 = x2 + b+2*a - g + 0.05;
y4_3 = x2 + 0.1328;

% 与上面关于原点对称
y4_4 = x2 - 0.1328;
y4_5 = x2 - b- 2*a + g - 0.05;
y4_6 = x2 - 1 + f*sqrt(2);
y4_7 = x2 - 1;


hold on

if plot_axis == 1 
    % 绘制横轴
    plot([-1.5,1.5],[0,0],'-')
    % 绘制纵轴
    plot([0,0],[-1.5,1.5],'-')
end
% 
% % 绘制辅助竖线
if plot_line == 1 
    plot([-2*b+d,-2*b+d],[-1.2,1.2],'-')
    plot([2*b-d,2*b-d],[-1.2,1.2],'-')
    plot([-2*b+c,-2*b+c],[-1.2,1.2],'-')
    plot([2*b-c,2*b-c],[-1.2,1.2],'-')
    plot([-2*b+c+e,-2*b+c+e],[-1.2,1.2],'-')
    plot([2*b-c-e,2*b-c-e],[-1.2,1.2],'-')

		%rectangle 函数还没有实现，用下面的子函数tiao_rectangle代替
    tiao_rectangle('Position',[-2*b -2*b 4*b 4*b], 'Curvature', 0, 'FaceColor', 'w', 'EdgeColor','m', 'LineWidth', 1)
    tiao_rectangle('Position',[-2*b -b 4*b 2*b], 'Curvature', 0, 'FaceColor', 'w', 'EdgeColor','m', 'LineWidth', 1)
    tiao_rectangle('Position',[-2*b+d -2*b 4*b-2*d 4*b], 'Curvature', 0, 'FaceColor', 'w', 'EdgeColor','m', 'LineWidth', 1)
    tiao_rectangle('Position',[-2*b -b-a 4*b 2*b+2*a], 'Curvature', 0, 'FaceColor', 'w', 'EdgeColor','m', 'LineWidth', 1)
    tiao_rectangle('Position',[-2*b -b-2*a 4*b 2*b+4*a], 'Curvature', 0, 'FaceColor', 'w', 'EdgeColor','m', 'LineWidth', 1)
    tiao_rectangle('Position',[-2*b+c -b-2*a 4*b-2*c 2*b+4*a], ... 
      'Curvature', 0,'FaceColor', 'w', 'EdgeColor','m', 'LineWidth', 1)
    tiao_rectangle('Position',[-2*b+c+e -b-2*a 4*b-2*c-2*e 2*b+4*a], ...
      'Curvature', 0,'FaceColor', [0,0,0], 'EdgeColor','m', 'LineWidth', 1)
    
    % 绘制辅助斜线
    plot(x1,y1_1)
    plot(x1,y1)
    plot(x1,y1_2)
    plot(x1,y3)
    plot(x2,y4)
    plot(x2,y4_1)
    plot(x2,y4_2)
    plot(x2,y4_3)
    plot(x2,y4_4)
    plot(x2,y4_5)
    plot(x2,y4_6)
    plot(x2,y4_7)
end





%%%%%%%%%%%%%%%%%%%%%%%%下面为填充logo %%%%%%%%%%%%%%%%%%%
% 以三角形的形式填充，需要提供三角形三个顶点的坐标
X = [2*b-d,2*b-c,2*b-c-e];
Y = [2*b, 0.95726-2*b+c,b];
X1 = [-X(1), -X(2), -X(2)];
Y1 = [-Y(3), -Y(2), -Y(3)];
Y2 = [-Y(3), -Y(3), b+a];

X2 = [-X(1), -X(1), -X(2)];
Y3 = [-Y(3), b+a, b+a];

X4 = [-X(1), -X(2), -X(2)];
Y4 = [b+a, b+a, 1-X(2)];

X5 = [-X(2), -X(2), 2*b-1];
Y5 = [b+2*a, 1-X(2), 2*b];

X6 = [-X(2), 2*b-1, (1.35043-f*sqrt(2))/2-1+f*sqrt(2)];
Y6 = [b+2*a, 2*b, (1.35043-f*sqrt(2))/2];

X7 = [-2*b+c, b+2*a-1 + f*sqrt(2), (1.35043-f*sqrt(2))/2-1+f*sqrt(2)];
Y7 = [b+2*a, b+2*a, (1.35043-f*sqrt(2))/2];

X8 = [-2*b+c, -2*b+c, b+2*a-1 + f*sqrt(2)];
Y8 = [-2*b+c+1-f*sqrt(2), b+2*a, b+2*a];

% 中间靠上的斜杠 下半部分
X9 = [-g, -g, g];
Y9 = [0, b+2*a-2*g+0.05, 0.1325+g];
% 中间靠上的斜杠 上半部分
X10 = [-g, g, g];
Y10 = [b+2*a-2*g+0.05, 0.1325+g, b+2*a+0.05];

X11 = [2*b-c-h, 2*b-c, 2*b-c];
Y11 = [j,0,i];

%fill命令的 'EdgeColor','none' 表示不画边框。
fill(X1, Y1,[0.514 0.106 0.125],'EdgeColor','none')
fill(X1, Y2,[0.514 0.106 0.125],'EdgeColor','none')
fill(X2, Y3,[0.514 0.106 0.125],'EdgeColor','none')
fill(X4, Y4,[0.514 0.106 0.125],'EdgeColor','none')
fill(X5, Y5,[0.514 0.106 0.125],'EdgeColor','none')
fill(X6, Y6,[0.514 0.106 0.125],'EdgeColor','none')
fill(X7, Y7,[0.514 0.106 0.125],'EdgeColor','none')
fill(X8, Y8,[0.514 0.106 0.125],'EdgeColor','none')
fill(X9, Y9,[0.514 0.106 0.125],'EdgeColor','none')
fill(X10, Y10,[0.514 0.106 0.125],'EdgeColor','none')


fill(X11, Y11,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X1, -Y1,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X1, -Y2,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X2, -Y3,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X4, -Y4,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X5, -Y5,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X6, -Y6,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X7, -Y7,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X8, -Y8,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X9, -Y9,[0.133,0.286,0.424],'EdgeColor','none')
fill(-X10, -Y10,[0.133,0.286,0.424],'EdgeColor','none')

axis([-1.5 1.5 -1.5 1.5])
axis square

hold off

function tiao_rectangle(Position, pos, Curvature, curv, FaceColor, fc, EdgeColor, ec, LineWidth, lw)
  len = length(curv);
  if (len >= 2) 
    horz_curv = curv(1);
    vert_curv = curv(2);
  elseif (len == 1)
    horz_curv = curv(1);
    vert_curv = curv(1);
  else
    horz_curv = 0;
    vert_curv = 0;
  end

  lux = pos(1); luy =pos(2); 
  width = pos(3); height = pos(4);


  if ( abs(horz_curv)<0.1 && abs(vert_curv) <0.1 )
    fx = [lux, lux+width, lux+width ,lux];
    fy = [luy, luy, luy+height, luy+height];
  else
    n = 15;
    p = pi / 2 * [0 : n] / n;
    c = curv .* pos(3:4) / 2;
    cx = c(1) * sin (p) - c(1);
    cy = c(2) * cos (p) - c(2);
    fx = [pos(1) - cx(n+1:-1:1), pos(1) + pos(3) + cx, ...
      pos(1) + pos(3) + cx(n+1:-1:1), pos(1) - cx, pos(1)];
    fy = [pos(2) - cy(n+1:-1:1), pos(2) - cy, ...
      pos(2) + pos(4) + cy(n+1:-1:1), ...
      pos(2) + pos(4) + cy, pos(2) + c(2)];
  end

  fill(fx, fy, fc, EdgeColor, ec, LineWidth, lw) 
end

