%我们支持匿名函数的嵌套定义
% 如 quandEx1.m 定义了一个脚本函数来计算
% 一元函数(由句柄fh作为参数)在一个区间[a,b]上的数值积分，
%使用的积分公式复合梯形积分公式, 把[a,b]区间均匀剖分成n个小区间
% quandEx1(fh, a, b, n) 是这个数值积分公式的调用方式
%我们可以定义一个新的匿名函数
% 这个匿名函数的自变量x 作为 quadEx1 的积分上限的参数，quadEx1 
% 的函数句柄又是一个匿名函数 @(t)t.^2 。 
disp("匿名函数的嵌套使用")
disp("你会得到一个解决1/3的数值积分来")
gh = @(x) quadEx1(@(t)t.^2,0,x,20);
% 例如，我们计算 gh(1),  应该得到一个和 1/3 想接近的数值积分

