%切比雪夫插值
%被插值的函数是Runge函数，这是一个使用均匀网格插值效果不佳的
%的函数，但是使用切比雪夫多项式的零点来插值则效果很好
%T_n(x) = cos(n arccos(x)), 它在[-1,1]中有n个单根
% x_p = cos(pi*(2p+1)/2n), p = 0,1,\cdots, n-1. 
n=31;
p=[0:n-1];
x=cos(pi.*(2.*p+1)./(2*n))；
y=frunge(x);
plot(x,y,'r-*');
hold('on');
m=91；
x1=linspace(-1,1,m);
y1=zeros(1,m);
for i=1:m
for k=1:n
a=1;
for j=1:k-1
a=a*(x1(1,i)-x(1,j))/(x(1,k)-x(1,j));
end
for j=k+1:n
a=a*(x1(1,i)-x(1,j))/(x(1,k)-x(1,j));
end
y1(1,i)=y1(1,i)+a*frunge(x(1,k));
end
end
plot(x1, y1)
hold('off');
