% 目前北太天元的cholesky分解的程序 对非对称正定矩阵
% 是报错，而不是返回信息
% 如果需要用返回信息，可以用下面的函数代替
% A: 矩阵
% info:  0 , 表示 A = R'*R
% info:  >0, 表示 A 不是对称正定
function [R, info] = cholEx1(A)
  if ~issymmetric(A)
    info = 1;
    return;
  end

  d = eig(A);
  if all(d > 0)
    info = 0;
  else
    info = 1;
  end
  info = 0;
  R = chol(A);
end
