%计算data的第一列和第二列之间的相关系数(Pearson correaltion coefficient)
r = function correlationEx1(data)
/*
data = [
3.63	53.1
3.02	49.7
3.82	48.4
3.42	54.2
3.59	54.9
2.87	43.7
3.03	47.2
3.46	45.2
3.36	54.4
3.3	50.4
]
*/

	[n,m] = size(data);
	x = data(:,1); y = data(:,2);

	sumx = sum(x);
	sumy = sum(y);
	sumx2 = sum(x.*x);
	sumy2 = sum(y.*y);
	sumxy = sum(x.*y);

	r = (n*sumxy - sumx *sumy )./sqrt( (n*sumx2 - (sumx).^2)*(n*sumy2-(sumy)^2 ) )

end

