%晒法判断一个数是否是素数

function result = isprimeEx1(n) %是用来判断一个数是不是素数
	if(nargin ~= 1)
		bxprinf("isprime 需要一个参数, 例如 isprime(13)\n");
		return;
	end

	if n <= 0 
		result = false;
		return; 	
	elseif n==1 || n == 2
		result =true;
		return;
	end

	m = floor(sqrt(n));
	
	for j=2:m
		if mod(n,j) == 0
			result = false;
			return;
		end
	end
	result = true; 
end
