% 设置图例的大小(FontSize), 
% 设置图例的位置(Location): 
% SouthWest 是左下, SouthEast 右下 
% NorthWest 是左上, NorthEast 右上
% 设置图例的字体(FontName), 这个比较麻烦，和系统有哪些字体可供使用有关系
% 默认的是 Times-Roman 
x=0:0.1:pi
plot(x,sin(x),x,sin(2*x),x,sin(3*x))  % 三条线
legend('sin(x)','sin(2x)','sin(3x)'); % 三个图例, 多余的图例设置会被忽略
legend('Location','SouthWest')
legend('FontName','Times-Roman')
legend('FontSize',36)
