%预优共轭梯度法
%陈静
n=5;
A=zeros(n,n);

% Ax = b 的 右端项 b
b=zeros(n,1);
b(1)=1;b(n)=1; 

L=eye(n,n);
for i=2:n
   L(i,i-1)=-1;
end
M=L*L';

%为矩阵A 赋值, A 是一个三对角矩阵
for i=2:n-1
   A(i,i)=2;
   A(i,i+1)=-1;
   A(i,i-1)=-1;
end
A(1,1)=2;A(1,2)=-1;
A(n,n)=2;A(n,n-1)=-1;

%迭代的初始值
x0=zeros(n,1);

k=0

%忍量
e=1e-7;

r=b-A*x0
z=inv(M)*r
p=z;
rou0=r'*z;
[x,r,p,rou,k]=PCG(A,M,x0,r,p,rou0,k)
while rou>rou0*e & k<1000
   [x,r,p,rou,k]=PCG(A,M,x,r,p,rou,k);
end
if k>=1000
   disp('failed')
else 
   k
   x
end
