% 绘制月饼
clear;clf
CSet=[0.92 0.51 0.11;1 0.7 0.09;0.87 0.41 0.05];
hold on


t = linspace(0,2*pi,640);
t1 = linspace(0, pi*0.5 - 0.15 ,160);
t2 = linspace(0.5*pi+0.15,  pi ,160);
t3 = linspace(pi, pi*1.5 - 0.15 ,160);
t4 = linspace(pi*1.5+ 0.15 ,2*pi,160);
hold on
axis square
% 最外层
plot(cos(t).*(11.7+1.5.*abs(cos(t.*7))), sin(t).*(11.7+1.5.*abs(cos(t.*7))),'Color',CSet(2,:),'LineWidth',10)
plot(cos(t).*(11+1.5.*abs(cos(t.*7))), sin(t).*(11+1.5.*abs(cos(t.*7))),'Color',CSet(2,:),'LineWidth',4)
% 外层第一个圆
plot(cos(t).*11 ,sin(t).*11,'Color',CSet(2,:),'LineWidth',10)
plot(cos(t).*10.3 ,sin(t).*10.3,'Color',CSet(2,:),'LineWidth',4)

% 第二个花环
plot(cos(t).*(9+abs(cos(t.*12))),sin(t).*(9+abs(cos(t.*12))),'Color',CSet(2,:),'LineWidth',4)
plot(cos(t).*9 ,sin(t).*9,'Color',CSet(2,:),'LineWidth',4)
plot(cos(t).*8.5 ,sin(t).*8.5,'Color',CSet(2,:),'LineWidth',2)


plot(cos(t).*7.5 ,sin(t).*7.5,'Color',CSet(2,:),'LineWidth',6)

plot(cos(t1).*6.5 ,sin(t1).*6.5,'Color',CSet(2,:),'LineWidth',6)
plot(cos(t2).*6.5 ,sin(t2).*6.5,'Color',CSet(2,:),'LineWidth',6)
plot(cos(t3).*6.5 ,sin(t3).*6.5,'Color',CSet(2,:),'LineWidth',6)
plot(cos(t4).*6.5 ,sin(t4).*6.5,'Color',CSet(2,:),'LineWidth',6)

plot(cos(t).*5.5 ,sin(t).*5.5,'Color',CSet(2,:),'LineWidth',6)

% plot([0 0],[-7 7]-0.3,'Color',CSet(3,:),'LineWidth',4)
% plot([-7 7],[0 0]-0.3,'Color',CSet(3,:),'LineWidth',4)
plot([0 0],[5.5 7.5],'Color',CSet(2,:),'LineWidth',6)
plot([0 0],[-5.5 -7.5],'Color',CSet(2,:),'LineWidth',6)

plot([-6.5 -7.5],[0 0],'Color',CSet(2,:),'LineWidth',6)
plot([6.5 7.5],[0 0],'Color',CSet(2,:),'LineWidth',6)




b = 0.3419;
a = b/7;
c = 0.8354*b;
d = 1.25*a;
e = 0.9104*c;
f = 0.6568*b;  %0.636364*b;
g = 0.38*b;
h = 0.22917*b;
i = 0.38542*b;
j = 0.17708*b;
k = 0.7385*b;
X = [2*b-d,2*b-c,2*b-c-e];
Y = [2*b, 0.95726-2*b+c,b];
X1 = [-X(1), -X(2), -X(2)];
Y1 = [-Y(3), -Y(2), -Y(3)];
Y2 = [-Y(3), -Y(3), b+a];

X2 = [-X(1), -X(1), -X(2)];
Y3 = [-Y(3), b+a, b+a];

X4 = [-X(1), -X(2), -X(2)];
Y4 = [b+a, b+a, 1-X(2)];

X5 = [-X(2), -X(2), 2*b-1];
Y5 = [b+2*a, 1-X(2), 2*b];

X6 = [-X(2), 2*b-1, (1.35043-f*sqrt(2))/2-1+f*sqrt(2)];
Y6 = [b+2*a, 2*b, (1.35043-f*sqrt(2))/2];

X7 = [-2*b+c, b+2*a-1 + f*sqrt(2), (1.35043-f*sqrt(2))/2-1+f*sqrt(2)];
Y7 = [b+2*a, b+2*a, (1.35043-f*sqrt(2))/2];

X8 = [-2*b+c, -2*b+c, b+2*a-1 + f*sqrt(2)];
Y8 = [-2*b+c+1-f*sqrt(2), b+2*a, b+2*a];

% 中间靠上的斜杠 下半部分
X9 = [-g, -g, g];
Y9 = [0, b+2*a-2*g+0.05, 0.1325+g];
% 中间靠上的斜杠 上半部分
X10 = [-g, g, g];
Y10 = [b+2*a-2*g+0.05, 0.1325+g, b+2*a+0.05];

X11 = [2*b-c-h, 2*b-c, 2*b-c];
Y11 = [j,0,i];

m = 6
X1 = m.*X1;
Y1 = m.*Y1;

X2 = m.*X2;
Y2 = m.*Y2;

Y3 = m.*Y3;

X4 = m.*X4;
Y4 = m.*Y4;

X5 = m.*X5;
Y5 = m.*Y5;

X6 = m.*X6;
Y6 = m.*Y6;

X7 = m.*X7;
Y7 = m.*Y7;

X8 = m.*X8;
Y8 = m.*Y8;

X9 = m.*X9;
Y9 = m.*Y9;

X10 = m.*X10;
Y10 = m.*Y10;

X11 = m.*X11;
Y11 = m.*Y11;


plot(X1(1:2),Y1(1:2), 'Color',CSet(2,:),'LineWidth',4)
plot(X1(2:3),[Y1(2),Y1(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(X2(1:2),Y3(1:2), 'Color',CSet(2,:),'LineWidth',4)
plot([X4(1),X4(3) ],[Y4(1),Y4(3)], 'Color',CSet(2,:),'LineWidth',4)
plot([X5(2),X5(3) ],[Y5(2),Y5(3)], 'Color',CSet(2,:),'LineWidth',4)
plot([X6(2),X6(3) ],[Y6(2),Y6(3)], 'Color',CSet(2,:),'LineWidth',4)
plot([X7(2),X7(3) ],[Y7(2),Y7(3)], 'Color',CSet(2,:),'LineWidth',4)
plot([X8(1),X8(3) ],[Y8(1),Y8(3)], 'Color',CSet(2,:),'LineWidth',4)
plot([X1(3),X8(1)],[Y1(3),Y8(1)], 'Color',CSet(2,:),'LineWidth',4)
plot([X9(1),X9(3) ],[Y9(1),Y9(3)], 'Color',CSet(2,:),'LineWidth',4)
plot([X9(1),X9(2) ],[Y9(1),Y9(2)], 'Color',CSet(2,:),'LineWidth',4)
plot([X10(1),X10(3) ],[Y10(1),Y10(3)], 'Color',CSet(2,:),'LineWidth',4)
plot([X10(2),X10(3) ],[Y10(2),Y10(3)], 'Color',CSet(2,:),'LineWidth',4)



plot(-X1(1:2),-Y1(1:2), 'Color',CSet(2,:),'LineWidth',4)
plot(-X1(2:3),-[Y1(2),Y1(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-X2(1:2),-Y3(1:2), 'Color',CSet(2,:),'LineWidth',4)
plot(-[X4(1),X4(3) ],-[Y4(1),Y4(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X5(2),X5(3) ],-[Y5(2),Y5(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X6(2),X6(3) ],-[Y6(2),Y6(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X7(2),X7(3) ],-[Y7(2),Y7(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X8(1),X8(3) ],-[Y8(1),Y8(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X9(1),X9(3) ],-[Y9(1),Y9(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X9(1),X9(2) ],-[Y9(1),Y9(2)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X10(1),X10(3) ],-[Y10(1),Y10(3)], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X10(2),X10(3) ],-[Y10(2),Y10(3)], 'Color',CSet(2,:),'LineWidth',4)

% 绘制小三角
plot(-[X8(1),X8(1) ],-[Y8(1),Y11(3)-0.8], 'Color',CSet(2,:),'LineWidth',4)
plot(-[X8(1),X8(1) ],-[Y11(2)-1.2,-Y8(3)], 'Color',CSet(2,:),'LineWidth',4)


% plot(-[X1(3),X8(1)],-[Y1(3),Y8(1)], 'Color',CSet(2,:),'LineWidth',4)


plot([X11(1),X11(3) ],-[Y11(1)-1,Y11(3)-0.8], 'Color',CSet(2,:),'LineWidth',4)
plot([X11(1),X11(2) ],-[Y11(1)-1,Y11(2)-1.2], 'Color',CSet(2,:),'LineWidth',4)


axis([-15 15 -15 15])

title("北太天元祝您中秋快乐！"); 
xlabel("http://www.baltamatica.com")

hold off
