%fh 需要是一个函数句柄，例如 fh = @sin
% quadEx1(fh,0,1,4) 将计算 sin(x)从0到1)的数值积分
%使用的是复合梯形形积分公式
function y = quadEx1(fh, a, b,n)
%h 是网格大小
	h = (b-a)/n;
%计算节点上的函数值
	v= fh(a:(b-a)/n:b);
%中间点权重是1， 两个端点的权重是0.5
	y = sum(v(2:end-1))+0.5*(v(1)+v(end));
%最后乘以网格大小		
	y= y*h;
end

%支持匿名函数的嵌套定义，如
%  gh = @(x) quadEx1(@(t)t.^2, 0, x, 5)
	
