%RSA 算法解密举例
% RSA 算法 原理， 需要找到两个素数 p, q, 然后让 n = p q 
% 欧拉函数phi(n) = （p-1）(q-1)
% 找到一个公钥     e  ,  使得   0< e < phi(n) 且与 phi(n) 互素
% 找到秘钥  d, 使得  mod( ed, phi(n)) = 1

% 加密:  x --> y =   mod( x^e, n)
% 解密:    x  = mod(y^d, n) 

%例子:  p = 13, q = 17 , n =221, phi(n) = 192,  
% d = 167 

% 这里的d 很大，直接计算 y^d 会发生上溢， 因此我们设计了下面的算法来计算
% 例如  x = 3 ,加密   mod(3^13, 221) = 113
 
% 计算  mod( 113 ^ 167 , 221) 

d = 167
xe = 113; 
s = xe;
for i = 1: d-1
	s = s* xe;
	s = mod( s, 221);
end
		
s
		  