%varargin 是一个特殊的形参，它会把用户输出的实参
%赋值给它前面的形参变量(例子里的是x) 之后，把别的输入
%实参组成一个cell赋值给 varargin
% 但是要求它必须是最后一个形参
%测试在用户没有把varargin 写成最后一个形参的时候，能否
%把 varargin后面的形参给忽略掉.
%下面的写法和 function = vararginEx2(x,varargin)等价
% 用户在调用这个函数的时候，例如
% y = vararginEx2(1,2,3,4)
%那么 x =1, varargin = {2,3,4}, z 会被忽略 
function y = vararginEx2(x,varargin,z)
  y = x+varargin{1,1}
end
